<template>
  <div id="app">
    <router-view />
    <router-link to="/user/1234">Go to user #1234</router-link>
    </br>
    <router-link to="/about">Go About</router-link>
    <!-- <router-link to="/user/1234" tag="li">Go to user #1234</router-link> -->
    <ul>
      <li v-for="(rent, city) in averageRent">
        The average rent in {{ city }} is ${{ rent }}
      </li>
    </ul>
    <p @click="handleChuyen">chuyen trang</p>
    <button v-bind:type="buttonType">Test button</button>
    <button v-bind:disabled="buttonDisabled">Test button</button>
    <p>{{ seconds }} seconds have elapsed since you opened the page.</p>
    <label><input type="radio" v-model="value" value="one" /> One</label>
    <label><input type="radio" v-model="value" value="two" /> Two</label>
    <label><input type="radio" v-model="value" value="three" /> Three</label>
    <p>Current status: {{ statusFromId(status) }}</p>
    <div v-html="yourHtml"></div>
    <ul>
      <li v-for="number in filterPositive(numbers)">{{ number }}</li>
    </ul>
    <p>The sum of the positive numbers is {{ getPositiveNumbersSum() }}</p>
    <p>Sum of numbers: {{ numberTotal }}</p>
    <p>doubleValue {{ doubleValue }}</p>
    <input type="text" v-model="inputValue" />
    <p>Five seconds ago, the input said "{{ oldInputValue }}".</p>
    <p>Product one cost: {{ productOneCost | formatCost("$") }}</p>
    <p>Product two cost: {{ productTwoCost | formatCost("$") }}</p>
    <p>Product three cost: {{ productThreeCost | formatCost("vn") }}</p>
    <button @click.self="increase">Click to increase counter</button>
    <p>You've clicked the button {{ counter }}</p>
    times.
    <div>
      <p v-hightlight>Custom Directives</p>
      <p v-bgcolor="'red'">Custom Directives</p>
      <p v-custom:background="'green'">Custom Directives</p>
      <p v-custom-local:background.delayed="'yellow'">Custom Directives</p>
    </div>
    <button @click="divVisible = !divVisible">Toggle visibility</button>
    <transition name="fade">
      <div v-if="divVisible">This content is sometimes hidden</div>
    </transition>
    <HelloWorld></HelloWorld>
    <CustomButtonComponent></CustomButtonComponent>
    <ColorViewComponent node="alehap" :price="price1"></ColorViewComponent>
    <ColorViewComponent
      color="blue"
      node="alibaba"
      :price="price2"
    ></ColorViewComponent>
    <DisplayNumberComponent :number="number"></DisplayNumberComponent>
    <div>parent {{ number1 }}</div>
    <CountFromNumberComponent :number.sync="number1"></CountFromNumberComponent>
    <div>parent {{ number2 }}</div>
    <CountFromNumberComponent
      :number="number2"
      @update:number="(val) => (number2 = val)"
    ></CountFromNumberComponent>
    <InputUsernameComponent
      :value="username"
      @input="(value) => (username = value)"
    ></InputUsernameComponent>
    <button @click="handleClick">Clicked {{ clicks }} times</button>
    <div v-bind:class="[firstClass, secondClass]">
      <p>nhuhuynh</p>
    </div>
    <div v-bind:class="classes">calss</div>
    <div v-bind:style="{ fontWeight: 'bold', color: 'red' }">dawdawd</div>
    <NotificationCount/>
  </div>
</template>  

<script>
import HelloWorld from "@/components/HelloWorld";
import CustomButtonComponent from "@/components/CustomButton";
import ColorViewComponent from "@/components/ColorView";
import DisplayNumberComponent from "@/components/DisplayNumber";
import CountFromNumberComponent from "@/components/CountFromNumber";
import InputUsernameComponent from "@/components/InputUsername";
import NotificationCount from "@/components/NotificationCount";
import Logs from "./helper/helper";

export default {
  mixins: [Logs],
  name: "App",
  data() {
    return {
      averageRent: {
        london: 1650,
        paris: 1730,
        NYC: 3680,
      },
      buttonType: "submit",
      buttonDisabled: true,
      seconds: 0,
      value: "one",
      yourHtml: "<p>in hoa ne <span style='color:red'>i</span></p>",
      status: 2,
      numbers: [-5, 0, 2, -1, 1, 0.5],
      value: 10,
      inputValue: "",
      oldInputValue: "",
      productOneCost: 998,
      productTwoCost: 2399,
      productThreeCost: 5300,
      counter: 0,
      divVisible: true,
      price1: 2,
      price2: 4,
      number: 0,
      number1: 10,
      number2: 20,
      username: "nhuhuynh",
      clicks: 0,
      firstClass: "foo",
      shouldBeBar: true,
    };
  },
  created() {
    this.logInfo();
    // console.log("AppComponent excute created");
    // setInterval(() => {
    //   this.number++;
    // }, 1000);
    setTimeout(() => {
      this.seconds++;
    }, 5000);
    setTimeout(() => {
      this.numberTotal = 10;
    }, 2000);
    setTimeout(() => {
      this.numbers.push(5);
    }, 4000);
  },
  beforeCreate() {
    console.log("AppComponent excute beforeCreate");
  },
  beforeMount() {
    console.log("AppComponent excute beforeMount");
  },
  mounted() {
    this.logInfo();
    console.log("AppComponent excute mounted");
    this.$nextTick(() => {
      // Element has definitely been added to the DOM
      console.log("nextTick");
    });
  },
  beforeUpdate() {
    // console.log("AppComponent excute beforeUpdate");
  },
  updated() {
    // console.log("AppComponent excute updated");
  },
  beforeDestroy() {
    console.log("AppComponent excute beforeDestroy");
  },
  destroyed() {
    console.log("AppComponent excute destroyed");
  },
  beforeRouteUpdate(to, from, next) {
    this.state = "loading";
    // this.init();
    console.log("trang chuyen App");
    next();
  },
  methods: {
    statusFromId(id) {
      const status = {
        0: "Asleep",
        1: "Eating",
        2: "Learning Vue",
      }[id];
      return status || "Unknown status: " + id;
    },
    filterPositive(numbers) {
      return numbers.filter((number) => number >= 0);
    },
    getPositiveNumbers() {
      // Note that we're now using this.numbers
      // to refer directly to the data object.
      return this.numbers.filter((number) => number >= 0);
    },
    getPositiveNumbersSum() {
      return this.getPositiveNumbers().reduce((sum, val) => sum + val);
    },
    increase(e) {
      console.log(e);
      this.counter++;
    },
    handleClick() {
      this.clicks++;
      this.$emit("count", this.clicks);
    },
    handleChuyen() {
     this.$router.push('/user/1234');
    }
  },
  computed: {
    numberTotal: {
      get() {
        return this.numbers.reduce((sum, val) => sum + val);
      },
      set(newValue) {
        console.log("set", this.value);
        const oldValue = this.numberTotal;
        const difference = newValue - oldValue;
        this.numbers.push(difference);
      },
    },
    doubleValue() {
      console.log(`doubleValue computed property changed ${this.value}`);
      return this.value * 2;
    },
    secondClass() {
      return "bar";
    },
    classes() {
      return {
        foo: true,
        bar: this.shouldBeBar,
        hello: false,
      };
    },
  },
  watch: {
    seconds() {
      console.log("seconds");
    },
    inputValue(val, oldVal) {
      console.log("input Value");
      console.log(val, oldVal);
      const newValue = this.inputValue;
      setTimeout(() => {
        this.oldInputValue = newValue;
      }, 5000);
    },
  },
  filters: {
    formatCost(value, symbol) {
      return symbol + (value / 100).toFixed(2);
    },
  },
  directives: {
    "custom-local": {
      bind(el, binding, vnode) {
        var delay = 0;
        if (binding.modifiers["delayed"]) {
          delay = 3000;
        }
        setTimeout(() => {
          if (binding.arg == "background") {
            el.style.backgroundColor = binding.value;
          } else {
            el.style.color = binding.value;
          }
        }, delay);
      },
    },
  },
  components: {
    HelloWorld,
    CustomButtonComponent,
    ColorViewComponent,
    DisplayNumberComponent,
    CountFromNumberComponent,
    InputUsernameComponent,
    NotificationCount
  },
};
</script>

<style>
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.5s;
}
.fade-enter,
.fade-leave-to {
  opacity: 0;
}
</style>
